"{" {   /* Code Blocks */

   /* GetStringRef, AppendToString: */
   /* implemented in lib/strings.c  */

   int blocklevel = 1;

   yysetpos();

   for(;;) {
      int ch = input(); yypos++;
      if (ch <= 0) {
	 yyerror("EOF inside action block");
	 break;
      }

      if (ch == '"' || ch == '\'') { /* strings, chars */
	 char this_terminator = ch;

	 AppendToString(this_terminator);
	 for(;;) {
	    ch = input(); yypos++;
	    if (ch <= 0) {
	       yyerror("EOF inside string");
	       break;
	    }
	    if (ch == '\\') { /* escape inside string */
               ch = input(); yypos++;
	       if (ch <= 0) {
		  yyerror("EOF inside string");
		  break;
	       }
	       AppendToString('\\');
	       AppendToString(ch);
	    }
	    else if (ch == this_terminator) {
	       break;
	    }
	    else
	       AppendToString(ch);
	 }
	 AppendToString(this_terminator);
      }

      else if (ch == '\\') { /* handle escaped characters */
	 ch = input(); yypos++;
	 if (ch <= 0) {
	    yyerror("EOF inside action block");
	    break;
	 }
	 AppendToString('\\');
	 AppendToString(ch);
      }

      else if (ch == '{') { /* nested action block */
	 blocklevel++;
	 AppendToString(ch);
      }
      else if (ch == '}') { /* end of (nested ?) action block */
	 blocklevel--;
	 if (blocklevel == 0) {
	    char *str;
	    GetStringRef(&str);
	    yylval.attr[1] = (long) str;
	    return CodeBlock;
	 }
	 else {
	    AppendToString(ch);
	 }
      }
      else if (ch == '/') { /* comment ? */
	 AppendToString('/');
	 ch = input(); yypos++;
	 if (ch == '*') { /* "/*"comment */
	    AppendToString('*');
	    ch = input(); yypos++;
	    for(;;) {
	       AppendToString(ch);
	       ch = input(); yypos++;
	       if (ch == '*') {
		  do {
	             AppendToString(ch);
		     ch = input(); yypos++;
		  } while (ch == '*');
		  if (ch == '/') {
	             AppendToString(ch);
		     break;
		  }
	       }
	       if (ch == '\n') {
		  AppendToString(ch);
		  yyPosToNextLine();
	       }
	       else if (ch <= 0) {
		  yyerror("EOF inside comment");
		  break;
	       }
	    }
	 }
	 else if (ch == '/') { /* "//" comment */
	    AppendToString('/');
	    ch = input(); yypos++;
	    for(;;) {
	       AppendToString(ch);
	       ch = input(); yypos++;
	       if (ch == '\n') {
		  AppendToString(ch);
		  yyPosToNextLine();
		  break;
	       }
	       else if (ch <= 0) {
		  yyerror("EOF inside comment");
		  break;
	       }
	    }
	 }
	 else {
            AppendToString(ch);
	 }
      }
      else {
         AppendToString(ch);
      }
      if (ch == '\n') {
	 yyPosToNextLine();
      }
   }
}
